<img src="https://raw.githubusercontent.com/dart-windows/.github/main/assets/dart-windows-card.png" width="50%" height="50%">

Provides an idiomatic Dart projection of the Windows Runtime (WinRT) APIs
from the `Windows.UI` namespace using Dart FFI.
Part of the [Dart | Windows][dart_windows_link] suite of Windows packages.

[![ci][ci_badge]][ci_link]
[![Package: windows_ui][package_badge]][package_link]
[![Publisher: win32.pub][publisher_badge]][publisher_link]
[![Language: Dart][language_badge]][language_link]
[![License: BSD-3-Clause][license_badge]][license_link]

## Documentation 📝

* [Overview and concepts][docs_link]
* [API reference][api_reference_link]

## Examples

The package contains several examples in the [example][example_link]
subdirectory, demonstrating how to invoke various Windows Runtime APIs from the
`Windows.UI` namespace.

## Feature requests and bugs

The WinRT APIs that are projected by this package are limited, but additional
APIs will be added based on user demand, especially if it helps facilitate the
development of new Dart packages for Windows.

If you encounter any issues or have any feature requests, please submit them
through the [issue tracker][issue_tracker_link].

## Acknowledgements

The summary WinRT API documentation comments are
[licensed by Microsoft][legal_notices_link] under the
[Creative Commons Attribution 4.0 International Public License][cc_license_link].

[api_reference_link]: https://pub.dev/documentation/windows_ui/latest/
[cc_license_link]: https://github.com/MicrosoftDocs/winrt-api/blob/89e9254fd8b53a648937dbb4324d7f7d6f8d1314/LICENSE
[ci_badge]: https://github.com/dart-windows/dartwinrt/actions/workflows/windows_ui.yml/badge.svg
[ci_link]: https://github.com/dart-windows/dartwinrt/actions/workflows/windows_ui.yml
[dart_windows_link]: https://github.com/dart-windows
[docs_link]: https://dartwinrt.dev
[example_link]: https://github.com/dart-windows/dartwinrt/tree/main/packages/windows_ui/example
[issue_tracker_link]: https://github.com/dart-windows/dartwinrt/issues
[language_badge]: https://img.shields.io/badge/language-Dart-blue.svg
[language_link]: https://dart.dev
[legal_notices_link]: https://github.com/MicrosoftDocs/winrt-api/#legal-notices
[license_badge]: https://img.shields.io/github/license/dart-windows/dartwinrt?color=blue
[license_link]: https://opensource.org/licenses/BSD-3-Clause
[package_badge]: https://img.shields.io/pub/v/windows_ui.svg
[package_link]: https://pub.dev/packages/windows_ui
[publisher_badge]: https://img.shields.io/pub/publisher/windows_ui.svg
[publisher_link]: https://pub.dev/publishers/win32.pub
